/*
  Algorithm.h

  Algorithm Implementation

  Autor: Daniela Slavkova
*/

#ifndef ALGORITHM_H
#define ALGORITHM_H 

/*--------------------------------------------------------------------------
  Included files to resolve specific definitions in this file
--------------------------------------------------------------------------*/
#include "stdafx.h"
#include <string>
#include <VECTOR>
#include <LIST>

using namespace std;

typedef vector<int> Array;
typedef vector<Array> List; 
typedef list<string> ListWords; 	

/*-------------------------------------------------------------------------
  Constant data
-------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------
  Exported data
-------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------
  Class declaration
-------------------------------------------------------------------------*/
// DictinaryCreation - data and algorithm
class DictionaryCreation
{
public:
	// Constructor
	DictionaryCreation()
	{
		WordMaxLength = 0;
		NewCurrPos = 0;
		InitialState = 0;

		SerializeFile = new char[strlen("TempFile.txt") + 1]; 
		strcpy(SerializeFile, "TempFile.txt");
		FlagExecutionErrors = false;
	}

	// Constructor
	DictionaryCreation(char* SerFile)
	{
		WordMaxLength = 0;
		NewCurrPos = 0;
		InitialState = 0;
		
		SerializeFile = new char[strlen(SerFile) + 1];  
		strcpy(SerializeFile, SerFile);
		FlagExecutionErrors = false;
	}
	
	// Destructor
	~DictionaryCreation()
	{
		delete SerializeFile;
	}
	
	void CreateMinAutomata(char* InFile, char* Table, char* Column);
	void SerializeArray();

	bool FlagExecutionErrors;
private:
	int NewState();
	int Final(int State);
	void SetFinal(int State, int IsFinal);
	int Transition(int s, char c);
	void SetTransition(int r, char c, int s);
	void ClearState(int s);
	int CopyState(int s);
	int Member(int State);	
	int FindMinimized(int s);
	int PrepareInputData(char* InFile, char* Table, char* Column);

	int WordMaxLength;					// max posiible length of word 
	int NewCurrPos;						// states count; point new possible position in Dict
	int InitialState;					// Initial state in dictionary

	List Dict;							// Dictionary of states and transitions 
	Array Fin;							// Final states indicator array

	char* SerializeFile;				// Serializating file name

	ListWords ArrayWords;				// Contain sort words from input file	
}; 

/*-------------------------------------------------------------------------
  Exported functions
-------------------------------------------------------------------------*/


#endif /* ALGORITHM_H */


