/*
  Alphabet.cpp

  Alphabet Implementation

  Autor: Daniela Slavkova
*/

/*--------------------------------------------------------------------------
  Body Identification
--------------------------------------------------------------------------*/
#define ALPHABET

/*-------------------------------------------------------------------------
  Included files
--------------------------------------------------------------------------*/
#include "stdafx.h"

#include "Alphabet.h"

/*--------------------------------------------------------------------------
  Local constants
--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------
  Local macro
--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------
  Local type
--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------
  Local data
--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------
  Constant local data
--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------
  Exported data
--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------
  Constant exported data
--------------------------------------------------------------------------*/
int ASCIICodes[256] =	{
						  // 0   1   2   3   4   5   6   7   8   9  
							-1, -1, -1, -1, -1, -1, -1, -1, -1, -1,  

						  //10  11  12  13  14  15  16  17  18  19  
							-1, -1, -1, -1, -1, -1, -1, -1, -1, -1,  
						  
						  //20  21  22  23  24  25  26  27  28  29  
							-1, -1, -1, -1, -1, -1, -1, -1, -1, -1,  

						  //30  31  32  33  34  35  36  37  38  39  
							-1, -1,  0, -1, -1, -1, -1, -1, -1, 43, 
							
						  //40  41  42  43  44  45  46  47  48  49  
							-1, -1, -1, -1, -1,  1, 42, -1,  2,  3,  

						  //50  51  52  53  54  55  56  57  58  59  
							 4,  5,  6,  7,  8,  9, 10, 11, -1, -1,  

						  //60  61  62  63  64  65  66  67  68  69  
							-1, -1, -1, -1, -1, -1, -1, -1, -1, -1,  

						  //70  71  72  73  74  75  76  77  78  79  
							-1, -1, -1, -1, -1, -1, -1, -1, -1, -1,  
						  
						  //80  81  82  83  84   85  86  87  88 89  
							-1, -1, -1, -1, -1, -1, -1, -1, -1, -1,  

						  //90  91  92  93  94  95  96  97  98  99  
							-1, -1, -1, -1, -1, -1, -1, 12, 13, 34, 
							
						  //100 101 102 103 104 105 106 107 108 109  
							16, 17, 32, 15, 33, 20, 18, 22, 23, 24,  

						  //110 111 112 113 114 115 116 117 118 119  
							25, 26, 27, 41, 28, 29, 30, 31, 14, 14,  

						  //120 121 122 123 124 125 126 127 128 129  
							38, 38, 19, -1, -1, -1, -1, -1, -1, -1,  

						  //130 131 132 133 134 135 136 137 138 139  
							-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
							
						  //140 141 142 143 144 145 146 147 148 149  
							-1, -1, -1, -1, -1, -1, -1, -1, -1, -1,  

						  //150 151 152 153 154 155 156 157 158 159  
							-1, -1, -1, -1, -1, -1, -1, -1, -1, -1,  

						  //160 161 162 163 164 165 166 167 168 169  
							-1, -1, -1, -1, -1, -1, -1, -1, -1, -1,  

						  //170 171 172 173 174 175 176 177 178 179  
							-1, -1, -1, -1, -1, -1, -1, -1, -1, -1,  
						  
						  //180 181 182 183 184 185 186 187 188 189  
							-1, -1, -1, -1, -1, -1, -1, -1, -1, -1,  

						  //190 191 192 193 194 195 196 197 198 199  
							-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
							
						  //200 201 202 203 204 205 206 207 208 209  
							-1, -1, -1, -1, -1, -1, -1, -1, -1, -1,  

						  //210 211 212 213 214 215 216 217 218 219  
							-1, -1, -1, -1, -1, -1, -1, -1, -1, -1,  

						  //220 221 222 223 224 225 226 227 228 229  
							-1, -1, -1, -1, 12, 13, 14, 15, 16, 17,  

						  //230 231 232 233 234 235 236 237 238 239  
							18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 
							
						  //240 241 242 243 244 245 246 247 248 249  
							28, 29, 30, 31, 32, 33, 34, 35, 36, 37,  

						  //250 251 252 253 254 255
							38, -1, 39, -1, 40, 41
						};


// Array from all posible characters in the words. 
// This is the alphabet.
char Characters[CharMapL] = {
									' ',		// pos 0
									'-',		// pos 1
									'0',		// pos 2
									'1',		// pos 3
									'2',		// pos 4
									'3',		// pos 5
									'4',		// pos 6
									'5',		// pos 7
									'6',		// pos 8
									'7',		// pos 9
									'8',		// pos 10
									'9',		// pos 11
									(char)224,  // pos 12			
									(char)225,  // pos 13
									(char)226,	// pos 14
									(char)227,	// pos 15
									(char)228,  // pos 16
									(char)229,  // pos 17
									(char)230,  // pos 18
									(char)231,	// pos 19
									(char)232,	// pos 20
									(char)233,	// pos 21
									(char)234,	// pos 22
									(char)235,	// pos 23
									(char)236,	// pos 24
									(char)237,	// pos 25
									(char)238,	// pos 26
									(char)239,	// pos 27
									(char)240,	// pos 28
									(char)241,	// pos 29
									(char)242,	// pos 30
									(char)243,	// pos 31
									(char)244,	// pos 32
									(char)245,	// pos 33
									(char)246,	// pos 34
									(char)247,	// pos 35
									(char)248,	// pos 36
									(char)249,	// pos 37
									(char)250,	// pos 38
									(char)252,	// pos 39
									(char)254,	// pos 40
									(char)255,	// pos 41
									'.',		// pos 42
									'\''		// pos 43
							};

// Abbreviations of titles
string AbbreviationMap[AbbreviationNumber][2] = 
{
	{"",		"."	},
	{"",		"-"	},
	{"",		"."	},
	{"",		"."	},
	{"",	"."	},
	{"",		"."	},
	{"",   "."	},
	{"",	"."	}
};

/*--------------------------------------------------------------------------
  Local function prototypes
--------------------------------------------------------------------------*/

/*============================================================================
============================= PRIVATE FUNCTIONS ==============================
============================================================================*/

/*============================================================================
============================== PUBLIC FUNCTIONS ========================
============================================================================*/

/*============================================================================
============================== LOCAL FUNCTIONS ===============================
============================================================================*/

/*============================================================================
============================= EXPORTED FUNCTIONS =============================
============================================================================*/

/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
  Description of function LowerCase(string Str): Convert a cyrillic 
  string to lowercase.
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
string LowerCase(string Str)
{
	int StrLen = Str.length();
	string ResStr = "";
	int ICh; 

	for(int I = 0; I < StrLen; I++)
	{
		ICh = (int)Str[I]; 
		if(
			((ICh >= -64) && (ICh <= -33)) || 
			((ICh >= 192) && (ICh <= 223)) ||
			((ICh >= 65) && (ICh <= 90))
		  )
		{
			ResStr.append(1, Str[I] + 32);
		}
		else
		{
			ResStr.append(1, Str[I]);
		}
	}

	return ResStr;
}

/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
  Description of function UpperCase(string Str): Convert a cyrillic 
  string to uppercase.
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
string UpperCase(string Str)
{
	int StrLen = Str.length();
	string ResStr = "";
	char Ch; 

	for(int I = 0; I < StrLen; I++)
	{
		Ch = Str[I]; 
		if(
			((Ch >= -64 + 32) && (Ch <= -33 + 32)) || 
			((Ch >= 192 + 32) && (Ch <= 223 + 32)) ||
			((Ch >= 65 + 32) && (Ch <= 90 + 32))
		  )
		{
			ResStr.append(1, Str[I] - 32);
		}
		else
		{
			ResStr.append(1, Str[I]);
		}
	}

	return ResStr;
}