/*
  Alphabet.h

  Alphabet Implementation

  Autor: Daniela Slavkova
*/

#ifndef ALPHABET_H
#define ALPHABET_H 

/*--------------------------------------------------------------------------
  Included files to resolve specific definitions in this file
--------------------------------------------------------------------------*/
#include "stdafx.h"
#include <STRING>

using namespace std;

/*-------------------------------------------------------------------------
  Constant data
-------------------------------------------------------------------------*/
// alphabet length
#define CharMapL			44
#define MissingTransition	-1
#define AbbreviationNumber	8

/*-------------------------------------------------------------------------
  Exported data
-------------------------------------------------------------------------*/
//extern int ASCIICodes[256];
extern int ASCIICodes[256];

// Array from all posible characters in the words. 
// This is the alphabet.
extern char Characters[CharMapL];


// Abbreviation
extern string AbbreviationMap[AbbreviationNumber][2];

/*-------------------------------------------------------------------------
  Class declaration
-------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------
  Exported functions
-------------------------------------------------------------------------*/
string LowerCase(string Str);
string UpperCase(string Str);

#endif /* ALPHABET_H */


