// FdaObj.cpp : Implementation of CFdaObj
#include "stdafx.h"
#include <fstream>
#include <string>
#include <comdef.h>


#include "AnalysisServer.h"

#include "FdaObj.h"

#include "Alphabet.h"
#include "Algorithm.h"
#include "RequestDictionary.h"
#include "ProcessingErrors.h"

using namespace std;

/////////////////////////////////////////////////////////////////////////////
// CFdaObj

STDMETHODIMP CFdaObj::CreateMinAutomata(BSTR newInputFile, BSTR newInputTableName, BSTR newInputColumnName, BSTR newOutputFile, long* newCheckResultCreate)
{		
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	//check and free, then copy
	SysFreeString(m_strInputFile);
	m_strInputFile= SysAllocStringByteLen((char*)newInputFile,
		SysStringByteLen(newInputFile));	

	//check and free, then copy
	SysFreeString(m_strOutputFile);
	m_strOutputFile= SysAllocStringByteLen((char*)newOutputFile,
		SysStringByteLen(newOutputFile));	

	//check and free, then copy
	SysFreeString(m_strTableName);
	m_strTableName = SysAllocStringByteLen((char*)newInputTableName,
		SysStringByteLen(newInputTableName));	

	//check and free, then copy
	SysFreeString(m_strColumnName);
	m_strColumnName= SysAllocStringByteLen((char*)newInputColumnName,
		SysStringByteLen(newInputColumnName));	

	_bstr_t bstrInFile, bstrOutFile;
	_bstr_t bstrInColumn, bstrInTable;

//	USES_CONVERSION;

	bstrInFile = _bstr_t(m_strInputFile,true);
	bstrOutFile = _bstr_t(m_strOutputFile,true);
	bstrInTable = _bstr_t(m_strTableName,true);
	bstrInColumn = _bstr_t(m_strColumnName,true);

	*newCheckResultCreate = 1;

	ProcessError("..................................Called CreateMinAutomata..................................");
	DictionaryCreation *CreationDict = new DictionaryCreation((char *)bstrOutFile);
	CreationDict->CreateMinAutomata((char *)bstrInFile, (char *)bstrInTable, (char *)bstrInColumn);
	if(CreationDict->FlagExecutionErrors == false)
	{
		ProcessError("Dictionary creation completes successfully.");
		CreationDict->SerializeArray();
		if(CreationDict->FlagExecutionErrors == false)
		{
		    ProcessError("Serialization completes successfully.");
			ProcessError("Server execution completes successfully.");
		}	
		else
		{
			ProcessError("Serialization completes with errors.");
			ProcessError("Server execution completes with errors.");
			*newCheckResultCreate = 0;
		}
	}
	else
	{
		ProcessError("Dictionary creation completes with errors.");
		ProcessError("Server execution completes with errors.");
		*newCheckResultCreate = 0;
	}

	delete CreationDict;

	return S_OK;
}

STDMETHODIMP CFdaObj::LoadDictionary(BSTR newDictionaryFile, long* newCheckResultLoad)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	//check and free, then copy
	SysFreeString(m_strOutputFile);
	m_strOutputFile= SysAllocStringByteLen((char*)newDictionaryFile,
		SysStringByteLen(newDictionaryFile));	

	_bstr_t bstrDictFile;

//	USES_CONVERSION;
	
	bstrDictFile = _bstr_t(m_strOutputFile,true);

	*newCheckResultLoad = 1;

	ProcessError("..................................Called LoadDictionary..................................");
	Dict = new Dictionary((char *)bstrDictFile);
	Dict->DeserializeArray();

	if(Dict->FlagExecutionErrors == false)
	{	
		ProcessError("Deserialization completes successfully.");
		ProcessError("Server execution completes successfully.");
	}
	else
	{
		ProcessError("Deserialization completes with errors.");
		ProcessError("Server execution completes with errors.");
		*newCheckResultLoad = 0;
	}

	return S_OK;
}

STDMETHODIMP CFdaObj::FreeDictionary()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	delete Dict;

	return S_OK;
}

STDMETHODIMP CFdaObj::Request(BSTR newRequestWord, long newLevenstienDistance, BSTR newResultsFile, long* newCheckResultRequest)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	//check and free, then copy
	SysFreeString(m_strResultFile);
	m_strResultFile= SysAllocStringByteLen((char*)newResultsFile,
		SysStringByteLen(newResultsFile));	

	//check and free, then copy
	SysFreeString(m_strRequest);
	m_strRequest= SysAllocStringByteLen((char*)newRequestWord,
		SysStringByteLen(newRequestWord));	
	
	_bstr_t bstrResultFile, bstrRequest;

//	USES_CONVERSION;

	bstrResultFile = _bstr_t(m_strResultFile,true);
	bstrRequest = _bstr_t(m_strRequest,true);

	*newCheckResultRequest = 1;

	ProcessError("..................................Called Request..................................");
	Dict->FlagExecutionErrors = false;
	Dict->RequestDictionary((char*)bstrRequest, newLevenstienDistance);
	if(Dict->FlagExecutionErrors == false)
	{
		ProcessError("Requesting completes successfully.");
		Dict->PrintGoodWords((char*)bstrResultFile);
		if(Dict->FlagExecutionErrors == false)
		{
			ProcessError("Results printing completes successfully.");
			ProcessError("Server execution completes successfully.");
		}
		else
		{
			ProcessError("Results printing completes with errors.");
			ProcessError("Server execution completes with errors.");
			*newCheckResultRequest = 0;
		}
	}
	else
	{
		ProcessError("Requesting completes with errors.");
		ProcessError("Server execution completes with errors.");
		*newCheckResultRequest = 0;
	}

	return S_OK;
}
