// FdaObj.h : Declaration of the CFdaObj

#ifndef __FDAOBJ_H_
#define __FDAOBJ_H_

#include "resource.h"       // main symbols
#include "RequestDictionary.h"
#include <fstream>


/////////////////////////////////////////////////////////////////////////////
// CFdaObj
class ATL_NO_VTABLE CFdaObj : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CFdaObj, &CLSID_FdaObj>,
	public IDispatchImpl<IFdaObj, &IID_IFdaObj, &LIBID_ANALYSISSERVERLib>
//	public IFdaObj
{
public:

	BSTR m_strInputFile;
	BSTR m_strOutputFile;
	BSTR m_strTableName;
	BSTR m_strColumnName;
	BSTR m_strRequest;
	BSTR m_strResultFile;
	
	Dictionary *Dict;


	CFdaObj()
	{
		m_strInputFile = NULL;
		m_strOutputFile = NULL;
		m_strTableName = NULL;
		m_strColumnName = NULL;
		m_strRequest = NULL;
		m_strResultFile = NULL;
	}

	~CFdaObj()
	{
		SysFreeString(m_strInputFile);
		SysFreeString(m_strOutputFile);
		SysFreeString(m_strTableName);
		SysFreeString(m_strColumnName);
		SysFreeString(m_strRequest);
		SysFreeString(m_strResultFile);
	}


DECLARE_REGISTRY_RESOURCEID(IDR_FDAOBJ)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CFdaObj)
	COM_INTERFACE_ENTRY(IFdaObj)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IFdaObj
public:
	STDMETHOD(CreateMinAutomata)(
									/*[in]*/ BSTR newInputFile, 
									/*[in]*/ BSTR newInputTableName, 
									/*[in]*/ BSTR newInputColumnName, 
									/*[in]*/ BSTR newOutputFile, 
									/*[out, retval]*/ long* newCheckResultCreate
								);
	STDMETHOD(LoadDictionary)(/*[in]*/ BSTR newDictionaryFile, /*[out, retval]*/ long* newCheckResultLoad);
	STDMETHOD(FreeDictionary)();
	STDMETHOD(Request)(
						/*[in]*/ BSTR newRequestWord, 
						/*[in]*/ long newLevenstienDistance, 
						/*[in]*/ BSTR newResultsFile,
						/*[out, retval]*/ long* newCheckResultRequest
					  );
};

#endif //__FDAOBJ_H_
