/*
  Levenstien.h

  Levenstien Implementation

  Autor: Daniela Slavkova
*/

#ifndef LEVENSTIEN_H
#define LEVENSTIEN_H 

/*--------------------------------------------------------------------------
  Included files to resolve specific definitions in this file
--------------------------------------------------------------------------*/
#include "stdafx.h"
#include <string>

using namespace std;

/*-------------------------------------------------------------------------
  Constant data
-------------------------------------------------------------------------*/
#define N 256
#define M 256

/*-------------------------------------------------------------------------
  Exported data
-------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------
  Class declaration
-------------------------------------------------------------------------*/
// Levestien distance calculation
class Levenstien
{
public:
	// Constructor
	Levenstien(string PatternWord, int LevenstienDist = 3)
	{
		Pattern = PatternWord;
		PatternLength = Pattern.length();

		GoodLevenstienDist = LevenstienDist;

		LevenshtienDistanceTable = new int[PatternLength + 1][M + 1];

		// boundary conditions 
		for(int j = 0; j <= M; j++)
		{
			LevenshtienDistanceTable[0][j] = j;
		}
	
		for(int i = 0; i <= PatternLength; i++)
		{
			LevenshtienDistanceTable[i][0] = i;
		}
		//FirstColumn = 0;
		FirstColumns[0] = 0;
		IndexFirstColumnArray = 0;
	}
	
	// Destructor
	~Levenstien()
	{
		delete [] LevenshtienDistanceTable;
	}

	int  LevenstienDistanceCalc(string T);	
	bool InsertIntoTable(char Ch, int Column);
	int GetLevenstienDist(int Index);
	void InitializeInitial(int Column);

	int GoodLevenstienDist;

	// intervals data
//	int FirstColumn;
	int FirstColumns[256];
	int IndexFirstColumnArray;
	int PatternLength;					// length of Pattern		

private:
	int Minimum(int a, int b);
	string Pattern;						// Pattern to search					
	int (*LevenshtienDistanceTable)[M + 1];	// Levenstien distance array
}; 

/*-------------------------------------------------------------------------
  Exported functions
-------------------------------------------------------------------------*/

#endif /* LEVENSTIEN_H */


