// CreateDictionaryDlg.cpp : Implementation file

#include "stdafx.h"
#include <afxdao.h>
#include "resource.h"
#include "CreateDictionaryDlg.h"
#include "database.h"
#include "SimpleClient.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCreateDictionaryDlg dialog

CCreateDictionaryDlg::CCreateDictionaryDlg(CString strDatabase, 
										   CString strTable,
										   CString strColumn,
										   CString strOutputFile,
										   CWnd* pParent /*=NULL*/)
	: CDialog(CCreateDictionaryDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRequestDlg)
	//}}AFX_DATA_INIT
	m_strDatabase = strDatabase;
	m_strTable = strTable;
	m_strColumn = strColumn;
	m_strOutputFile = strOutputFile;
	m_pDatabase = NULL;
}

void CCreateDictionaryDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRequestDlg)
	DDX_Text(pDX, IDC_DATABASE, m_strDatabase);
	DDX_Control(pDX, IDC_TABLE, m_TableNameComboControl);
	DDX_Text(pDX, IDC_TABLE, m_strTable);
	DDX_Text(pDX, IDC_COLUMN, m_strColumn);
	DDX_Control(pDX, IDC_COLUMN, m_ColumnNameComboControl);
	DDX_Text(pDX, IDC_OUTPUTFILE, m_strOutputFile);
	//}}AFX_DATA_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CCreateDictionaryDlg dialog

BOOL CCreateDictionaryDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	CenterWindow();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);         // Set big icon
	SetIcon(m_hIcon, FALSE);        // Set small icon
	
	// TODO: Add extra initialization here
	CLSID clsID;
	HRESULT hr;

	hr= CLSIDFromProgID(OLESTR("AnalysisServer.FdaObj"), &clsID);
	if(FAILED(hr))
	{
		AfxMessageBox("Retrieval of ProgID failed");
		return FALSE;
	}
	m_pFdaObj.CreateInstance(clsID); //does the work of CoCreateInstance

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CCreateDictionaryDlg::OnButtonBrowse()

void CCreateDictionaryDlg::OnButtonBrowse()
{
	// allow user to select database to open
	CFileDialog dlg (TRUE, _T("mdb"), NULL, OFN_HIDEREADONLY,
					 _T("Access Database Files (*.mdb)|*.mdb||"),
					 this);

	// if user selected a file then open it as a database
	if (IDOK == dlg.DoModal())
	{
		// get full path to database file
		m_strDatabase = dlg.GetPathName();

		// display the name of the database on the dialog
		UpdateData(FALSE);
		m_TableNameComboControl.ResetContent();
		m_ColumnNameComboControl.ResetContent();


		CButton *pButtonCreateDictionary = (CButton *)GetDlgItem(IDC_BUTTON_CREATE);

		// now open the database if possible
		closeDatabase(&m_pDatabase);
		int retCode = openDatabase(&m_pDatabase, m_strDatabase);
		if(1 == retCode)
		{
			m_TableNameComboControl.EnableWindow(TRUE);
			m_ColumnNameComboControl.EnableWindow(TRUE);
			pButtonCreateDictionary->EnableWindow(TRUE);
			closeDatabase(&m_pDatabase);
		}
		else
		{
			m_TableNameComboControl.EnableWindow(FALSE);
			m_ColumnNameComboControl.EnableWindow(FALSE);
			pButtonCreateDictionary->EnableWindow(TRUE);
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// CCreateDictionaryDlg::OnButtonCreateDictionary()

void CCreateDictionaryDlg::OnButtonCreateDictionary()
{
	_bstr_t newbstrInputDBFile, newbstrOutputFile;
	_bstr_t newbstrInputTableName, newbstrInputColumnName;

	CString tmpCInputDBFile, tmpCOutputFile;
	CString tmpCInputTableName, tmpCInputColumnName;

	GetDlgItemText(IDC_DATABASE, tmpCInputDBFile);
	GetDlgItemText(IDC_OUTPUTFILE, tmpCOutputFile);
	GetDlgItemText(IDC_TABLE, tmpCInputTableName);
	GetDlgItemText(IDC_COLUMN, tmpCInputColumnName);

	m_strDatabase = tmpCInputDBFile;
	m_strTable = tmpCInputTableName;
	m_strColumn = tmpCInputColumnName;
	m_strOutputFile = tmpCOutputFile;

	newbstrInputDBFile = tmpCInputDBFile;
	newbstrOutputFile = tmpCOutputFile;
	newbstrInputTableName = tmpCInputTableName;
	newbstrInputColumnName = tmpCInputColumnName;

	closeDatabase(&m_pDatabase);

	CWnd myWindow;

	CTime myFirstTime = CTime::GetCurrentTime();
	
	int iCheckResult;
	iCheckResult = m_pFdaObj->CreateMinAutomata(newbstrInputDBFile, newbstrInputTableName, newbstrInputColumnName, newbstrOutputFile);
	
	CTime mySecondTime = CTime::GetCurrentTime();

	// request duration
	CTimeSpan myDuration = mySecondTime - myFirstTime; 

	// iCheckResult == 1 -> OK; iCheckResult == 0 -> NOK; 
	if(iCheckResult == 1)
	{
		myWindow.MessageBox(myDuration.Format("Execution OK. Perfomance: %D days, %H hours, %M minutes, %S seconds"), _T("Performance"));	
	}
	else
	{
		myWindow.MessageBox(myDuration.Format("Execution NOK. Performance: %D days, %H hours, %M minutes, %S seconds"), _T("Performance"));	
	}
}

/////////////////////////////////////////////////////////////////////////////
// CCreateDictionaryDlg::OnDropdownComboTableName()
// user wants to browse existing tables so fill in the combobox

void CCreateDictionaryDlg::OnDropdownComboTableName()
{
	int index = 0;
	CDaoTableDefInfo TableInfo;
	CDaoFieldInfo ColumnInfo;

	// clear out any items in control
	m_TableNameComboControl.ResetContent();

	// while there are tables to get information on, continue
	// this is a get info by index, not name and no error
	// reporting is done (specified by FALSE)
		
	// now open the database if possible
	closeDatabase(&m_pDatabase);
	int retCode = openDatabase(&m_pDatabase, m_strDatabase);
	if(1 == retCode)
	{
		while (getTableInfo(m_pDatabase, &TableInfo, index, FALSE))
		{
			// add to list box if not a system object (i.e. system table)
			// or hidden object
			if (!(TableInfo.m_lAttributes & dbSystemObject)
				&& !(TableInfo.m_lAttributes & dbHiddenObject))
			{
				m_TableNameComboControl.AddString(TableInfo.m_strName);
			}

			// continue loop
			index += 1;
		}

		closeDatabase(&m_pDatabase);
	}	
}

/////////////////////////////////////////////////////////////////////////////
// CCreateDictionaryDlg::OnDropdownComboColumnName()
// user wants to browse existing fields in table so fill in the combobox

void CCreateDictionaryDlg::OnDropdownComboColumnName()
{
	short index;

	// clear out any items in control
	m_ColumnNameComboControl.ResetContent();

	// now open the database if possible
	closeDatabase(&m_pDatabase);
	int retCode = openDatabase(&m_pDatabase, m_strDatabase);
	if(1 == retCode)
	{

		CDaoTableDef TableInfo(m_pDatabase);
		CDaoFieldInfo ColumnInfo;

		CString TableName;
		GetDlgItemText(IDC_TABLE, TableName);
		
		try
		{
			TableInfo.Open(TableName);
			short nFields = TableInfo.GetFieldCount();
			for(index = 0; index < nFields; index++)
			{
				TableInfo.GetFieldInfo(index,ColumnInfo);
				m_ColumnNameComboControl.AddString(ColumnInfo.m_strName);		
			}
		}
		catch( CDaoException* e )
		{
			// Do nothing. Used to catch security violations opening tables.
			e->Delete( );
		}
		TableInfo.Close( );	

		closeDatabase(&m_pDatabase);
	}
}

BEGIN_MESSAGE_MAP(CCreateDictionaryDlg, CDialog)
	//{{AFX_MSG_MAP(CCreateDictionaryDlg)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_BUTTON_BROWSE, OnButtonBrowse)
	ON_BN_CLICKED(IDC_BUTTON_CREATE, OnButtonCreateDictionary)
	ON_CBN_DROPDOWN(IDC_TABLE, OnDropdownComboTableName)
	ON_CBN_DROPDOWN(IDC_COLUMN, OnDropdownComboColumnName)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
