// RequestDlg.cpp : Implementation file

#include "stdafx.h"
#include "resource.h"
#include "RequestDlg.h"
#include <FSTREAM>
#include <STRING>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

using namespace std;

/////////////////////////////////////////////////////////////////////////////
// CRequestDlg dialog

CRequestDlg::CRequestDlg(CString iStorageFile, 
						 CWnd* pParent /*=NULL*/)
	: CDialog(CRequestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRequestDlg)
	//}}AFX_DATA_INIT
	m_strRequestedWord = _T("");
	m_strResultsFile = _T("Results.txt");
	m_nLevenstienDistance = 3;
	m_strStorageFile = iStorageFile;

	
	Button.LoadBitmaps(_T("IDB_BITMAP1D"), _T("IDB_BITMAP1U"), _T("IDB_BITMAP1F"), _T("IDB_BITMAP1I"));

}

CRequestDlg::~CRequestDlg()
{
	CFile f;
	CFileException e;
	const char* pFileName = (LPCTSTR)m_strStorageFile;

	if( !f.Open( pFileName, CFile::modeRead, &e ) )
	{
	}
	else
	{ 
		f.Close();
		m_pFdaObj->FreeDictionary();
	}
}

void CRequestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRequestDlg)
	DDX_Text(pDX, IDC_REQUEST, m_strRequestedWord);
	DDX_Text(pDX, IDC_RESULTSFILE, m_strResultsFile);
	DDX_Text(pDX, IDC_DISTANCE, m_nLevenstienDistance);
	//}}AFX_DATA_MAP
}

/////////////////////////////////////////////////////////////////////////////
// CRequestDlg::OnInitDialog

BOOL CRequestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	CenterWindow();

	// subclass the control
	VERIFY(m_ListBox.SubclassDlgItem(IDC_LISTRESULTS, this));

	VERIFY(Button.SubclassDlgItem(IDC_MORERESULTS, this));
	Button.SizeToContent();

	// TODO: Add extra initialization here
	CLSID clsID;
	HRESULT hr;

	hr= CLSIDFromProgID(OLESTR("AnalysisServer.FdaObj"), &clsID);
	if(FAILED(hr))
	{
		AfxMessageBox("Retrieval of ProgID failed");
		return FALSE;
	}
	m_pFdaObj.CreateInstance(clsID); //does the work of CoCreateInstance

	CFile f;
	CFileException e;
	const char* pFileName = (LPCTSTR)m_strStorageFile;
	
	CEdit *pEditRequest = (CEdit *)GetDlgItem(IDC_REQUEST);
	CEdit *pEditDistance = (CEdit *)GetDlgItem(IDC_DISTANCE);
	CEdit *pEditResults = (CEdit *)GetDlgItem(IDC_RESULTSFILE);
	CButton *pButtonMakeRequest = (CButton *)GetDlgItem(IDC_MAKE_REQUEST);
	
	if( !f.Open( pFileName, CFile::modeRead, &e ) )
	{
		// afxDump << "File could not be opened " << e.m_cause << "\n";
		pEditRequest->EnableWindow(false);

		pEditDistance->EnableWindow(false);

		pEditResults->EnableWindow(false);


		pButtonMakeRequest->EnableWindow(false);
	}
	else
	{
		_bstr_t newbstrStrageFile;
		newbstrStrageFile = m_strStorageFile;
 
		f.Close();
		int iCheckResult;
		iCheckResult = m_pFdaObj->LoadDictionary(newbstrStrageFile);
		
		// iCheckResult == 1 -> OK; iCheckResult == 0 -> NOK;
		if(iCheckResult == 1)
		{
			pEditRequest->EnableWindow(true);

			pEditDistance->EnableWindow(true);

			pEditResults->EnableWindow(true);

			pButtonMakeRequest->EnableWindow(true);
		}
		else
		{
			pEditRequest->EnableWindow(false);

			pEditDistance->EnableWindow(false);

			pEditResults->EnableWindow(false);

			pButtonMakeRequest->EnableWindow(false);
		
		}
	}

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CRequestDlg::OnButtonMakeRequest

void CRequestDlg::OnButtonMakeRequest()
{
	_bstr_t newbstrRequest, newbstrResultFile;

	CString tmpCRequest, tmpCResultFile;
	UINT tmpLevenstienDistance;

	GetDlgItemText(IDC_REQUEST, tmpCRequest);
	GetDlgItemText(IDC_RESULTSFILE, tmpCResultFile);
	tmpLevenstienDistance = GetDlgItemInt(IDC_DISTANCE);

	newbstrRequest = tmpCRequest;
	newbstrResultFile = tmpCResultFile;

	CWnd myWindow;

	SYSTEMTIME timeDestFirst, timeDestSecond;

	// begin request
	GetSystemTime(&timeDestFirst);
	long TimeFirstMs = timeDestFirst.wHour * 60 * 60 * 1000 +
					      timeDestFirst.wMinute * 60 * 1000 +
					       	   timeDestFirst.wSecond * 1000 +
						        timeDestFirst.wMilliseconds;
	// request
	int iCheckResult;
	iCheckResult = m_pFdaObj->Request(newbstrRequest, tmpLevenstienDistance, newbstrResultFile);

	// end request
	GetSystemTime(&timeDestSecond);
	long TimeSecondMs = timeDestSecond.wHour * 60 * 60 * 1000 +
					       timeDestSecond.wMinute * 60 * 1000 +
					       	    timeDestSecond.wSecond * 1000 +
						         timeDestSecond.wMilliseconds;


	// request duration
	long TimeDuration = TimeSecondMs - TimeFirstMs; 

	int nHour = TimeDuration / (60 * 60 * 1000);
	TimeDuration = TimeDuration % (60 * 60 * 1000);
	int nMinute = TimeDuration / (60 * 1000);
	TimeDuration = TimeDuration % (60 * 1000);
	int nSecond = TimeDuration / 1000;
	int nMilliseconds = TimeDuration % 1000;

	char  szTime[8];

	wsprintf(szTime, _T("%02i h:%02i min:%02i sec:%02i ms"), nHour, nMinute, nSecond, nMilliseconds);
	
	CString TimeDurationStr = szTime;

	// iCheckResult == 1 -> OK; iCheckResult == 0 -> NOK;
	if(iCheckResult == 1)
	{
		myWindow.MessageBox(_T("Executon OK. Performance: ") + TimeDurationStr, _T("Performance"));	
	}
	else
	{
		myWindow.MessageBox(_T("Executon NOK. Performance: ") + TimeDurationStr, _T("Performance"));	
	}
	
    // Initialize NumDistance
    NumDistance = 0;

	// display results
	fstream FsOut(tmpCResultFile, ios::in);
	
	string GoodWord;
	char* GoodWordsChars;
	CString Results;

	for(int I = m_ListBox.GetCount() - 1; I >= 0; I--)
	{
		m_ListBox.DeleteString(I);
	}
	
	int Pos, NumLast;
	string NumStr;

	if(FsOut.is_open())
	{
//		while(!(FsOut.eof()))
//		{
//			getline(FsOut, GoodWord);
//
//			GoodWordsChars = (char*)GoodWord.c_str();
//			Results = GoodWordsChars;
//			if(Results != "")
//			{
//				m_ListBox.AddString(Results);
//			}
//		}

		if(!(FsOut.eof()))
		{
			getline(FsOut, GoodWord);
			
			Pos = GoodWord.find(' ');
			NumStr = GoodWord.substr(0, Pos);
			NumLast = atoi(NumStr.c_str());
		
		}

		while(!(FsOut.eof()))
		{
			GoodWord = GoodWord.substr(Pos+1);

			GoodWordsChars = (char*)GoodWord.c_str();
			Results = GoodWordsChars;
			if(Results != "")
			{
				m_ListBox.AddString(Results);
			}

            getline(FsOut, GoodWord);
			
			Pos = GoodWord.find(' ');
			
            if(Pos != -1)
            {
                NumStr = GoodWord.substr(0, Pos);
			    NumDistance = atoi(NumStr.c_str());

    		    CButton *pButtonMoreResults = (CButton *)GetDlgItem(IDC_MORERESULTS);

			    if(NumDistance != NumLast)
			    {
				    pButtonMoreResults->EnableWindow(true);
				    break;
			    }
                else
                {
                    pButtonMoreResults->EnableWindow(false);
                }
            
            }
            else
            {
                CButton *pButtonMoreResults = (CButton *)GetDlgItem(IDC_MORERESULTS); 
                pButtonMoreResults->EnableWindow(false);
            }
		}

		FsOut.close();
	}
}

/////////////////////////////////////////////////////////////////////////////
// CRequestDlg::OnButtonMoreResults

void CRequestDlg::OnButtonMoreResults()
{

//	int Res = AfxMessageBox("Do you want more results?", MB_YESNO);
//	if(Res == IDYES)
//    {
 	    CString tmpCResultFile;
    	GetDlgItemText(IDC_RESULTSFILE, tmpCResultFile);
        
        // display results
	    fstream FsOut(tmpCResultFile, ios::in);
	    
	    string GoodWord;
	    char* GoodWordsChars;
	    CString Results;

	    for(int I = m_ListBox.GetCount() - 1; I >= 0; I--)
	    {
		    m_ListBox.DeleteString(I);
	    }
	    
	    int Num, Pos;
	    string NumStr;

	    if(FsOut.is_open())
	    {
		    while(!(FsOut.eof()))
		    {
			    getline(FsOut, GoodWord);
			    
			    Pos = GoodWord.find(' ');
			    if(Pos != -1)
                {
                    NumStr = GoodWord.substr(0, Pos);
			        Num = atoi(NumStr.c_str());
		    
			        GoodWord = GoodWord.substr(Pos+1);

			        GoodWordsChars = (char*)GoodWord.c_str();
			        Results = GoodWordsChars;

                    if(Num <= NumDistance)
                    {
                        m_ListBox.AddString(Results);
                    }
                    else
                    {
                        NumDistance = Num;
                        break;                    
                    }
                }
                else
                {
                    CButton *pButtonMoreResults = (CButton *)GetDlgItem(IDC_MORERESULTS); 
                    pButtonMoreResults->EnableWindow(false);
                }

		    }

		    FsOut.close();
	    }
   
//    }
		
}

BEGIN_MESSAGE_MAP(CRequestDlg, CDialog)
	//{{AFX_MSG_MAP(CRequestDlg)
	ON_BN_CLICKED(IDC_MAKE_REQUEST, OnButtonMakeRequest)
	ON_BN_CLICKED(IDC_MORERESULTS, OnButtonMoreResults)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
