// WndList.cpp : Implementation file

#include "stdafx.h"
#include <afxpriv.h>
#include "resource.h"
#include "WndClient.h"
#include "RequestDlg.h"
#include "CreateDictionaryDlg.h"
#include <FSTREAM>
#include <STRING>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

using namespace std;

/////////////////////////////////////////////////////////////////////////////
// CWndClientDlg control bar data

static UINT auIDStatusBar[] = {
   ID_SEPARATOR,
   ID_INDICATOR_TIME
};

static UINT auIDToolBar[] = {
   ID_APP_EXIT,
//   ID_SEPARATOR,
//   ID_OPTION_NOW,
//   ID_OPTION_RATE,
   ID_SEPARATOR,
   ID_HELP_ABOUT
};

/////////////////////////////////////////////////////////////////////////////
// CWndClientDlg dialog

CWndClientDlg::CWndClientDlg()
{
	//{{AFX_DATA_INIT(CWndClientDlg)
	//}}AFX_DATA_INIT
	m_nIDTimer = 0;
	m_strRequestWord = _T("");
    m_iTicks = 0;
//	m_strMessages = _T("");
	m_strStorageFile = _T("");
}


BOOL CWndClientDlg::Create()
{
	return CModelessMain::Create(CWndClientDlg::IDD,
								 auIDStatusBar,
								 sizeof(auIDStatusBar)/sizeof(UINT),
								 auIDToolBar,
								 sizeof(auIDToolBar)/sizeof(UINT),
								 IDR_MAIN);
}

void CWndClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CModelessMain::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWndClientDlg)
//	DDX_Text(pDX, IDC_MESSAGES, m_strMessages);
	DDX_Text(pDX, IDC_STORAGEFILE, m_strStorageFile);
//	DDX_Text(pDX, IDC_LOGS, m_strLogs);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWndClientDlg, CModelessMain)
	//{{AFX_MSG_MAP(CWndClientDlg)
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_COMMAND(ID_OPTION_CREATE, OnOptionCreate)
	ON_COMMAND(ID_OPTION_REQUEST, OnOptionRequest)
	ON_BN_CLICKED(IDC_BUTTON_STORAGEFILE, OnButtonOpen)
	//}}AFX_MSG_MAP
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_TIME, OnUpdateTime)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CWndClientDlg::OnInitDialog

BOOL CWndClientDlg::OnInitDialog()
{
	CModelessMain::OnInitDialog();

	// Initialize windows listbox contents

	// subclass the control
	VERIFY(m_ListLogs.SubclassDlgItem(IDC_LIST_LOGS, this));
	// display results
	fstream FsOut("LogFile.txt", ios::in);
	
	string Log;
	char* LogChars;
	CString Logs;

	for(int I = m_ListLogs.GetCount() - 1; I >= 0; I--)
	{
		m_ListLogs.DeleteString(I);
	}
	
	if(FsOut.is_open())
	{
		while(!(FsOut.eof()))
		{
			getline(FsOut, Log);

			LogChars = (char*)Log.c_str();
			Logs = LogChars;
			if(Logs != "")
			{
				m_ListLogs.AddString(Logs);
			}
		}

		FsOut.close();
	}


//	CFile f;
//	CFileException e;
//	const char* pFileName = (LPCTSTR)"papa.txt";
//		
//	if( !f.Open( pFileName, CFile::modeRead, &e ) )
//	{
//	
//	}
//	else
//	{
//		pFileName->Seek(3);
//		//LONG len = f.SeekToEnd();
//		f.SeekToBegin();
//
//		char pbuf[100];
//		UINT p = f.Read(pbuf, 100);
//		CString Logs = pbuf;
//		
//		CRichEditCtrl *pEdit = (CRichEditCtrl *)GetDlgItem(IDC_LOGS);
//
//		pEdit->SetDlgItemText(0, Logs);
//
//		SetDlgItemText(IDC_LOGS, Logs);
//	}



	// Set up a 1 second timer
	m_nIDTimer = SetTimer(1, 1000, NULL);
	if (!m_nIDTimer)
		AfxMessageBox(IDP_NOTIMER);

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CWndClientDlg::OnClose

void CWndClientDlg::OnClose()
{
	CModelessMain::OnClose();
}

/////////////////////////////////////////////////////////////////////////////
// CWndClientDlg::OnOptionCreate()

void CWndClientDlg::OnOptionCreate()
{
	m_iTicks = 0;
	GetDlgItemText(IDC_STORAGEFILE, m_strStorageFile);

	CCreateDictionaryDlg dlg(/*"db1.mdb"*/"", /*"NAMES"*/"", /*"NAME"*/"", m_strStorageFile, this);
	if (dlg.DoModal() == IDCANCEL)
	{
		m_strStorageFile = dlg.GetRequest();
		SetDlgItemText(IDC_STORAGEFILE, m_strStorageFile);

		// display results
		fstream FsOut("LogFile.txt", ios::in);
		
		string Log;
		char* LogChars;
		CString Logs;

		for(int I = m_ListLogs.GetCount() - 1; I >= 0; I--)
		{
			m_ListLogs.DeleteString(I);
		}
		
		if(FsOut.is_open())
		{
			while(!(FsOut.eof()))
			{
				getline(FsOut, Log);

				LogChars = (char*)Log.c_str();
				Logs = LogChars;
				if(Logs != "")
				{
					m_ListLogs.AddString(Logs);
				}
			}

			FsOut.close();
		}
	} 	
}

/////////////////////////////////////////////////////////////////////////////
// CWndClientDlg::OnOptionRequest()

void CWndClientDlg::OnOptionRequest()
{
	GetDlgItemText(IDC_STORAGEFILE, m_strStorageFile);
	CRequestDlg dlg(m_strStorageFile, this);
	if (dlg.DoModal() == IDCANCEL)
	{
		// display results
		fstream FsOut("LogFile.txt", ios::in);
		
		string Log;
		char* LogChars;
		CString Logs;

		for(int I = m_ListLogs.GetCount() - 1; I >= 0; I--)
		{
			m_ListLogs.DeleteString(I);
		}
		
		if(FsOut.is_open())
		{
			while(!(FsOut.eof()))
			{
				getline(FsOut, Log);

				LogChars = (char*)Log.c_str();
				Logs = LogChars;
				if(Logs != "")
				{
					m_ListLogs.AddString(Logs);
				}
			}

			FsOut.close();
		}	
	}
	//m_strRequestWord = dlg.GetRequest();
}

/////////////////////////////////////////////////////////////////////////////
// CWndClientDlg::OnUpdateTime()
// OnUpdateTime updates the status bar clock.

void CWndClientDlg::OnUpdateTime(CCmdUI* pCmdUI)
{
	CTime t = CTime::GetCurrentTime();
	char  szTime[8];
	int   nHour = t.GetHour();
	int   nMinute = t.GetMinute();
	int   nSecond = t.GetSecond();

	SYSTEMTIME timeDest;
	t.GetAsSystemTime(timeDest);

	// Base hours on 12 instead of 24
	if (nHour > 12)
		nHour -= 12;

	wsprintf(szTime, _T("%02i:%02i:%02i"), nHour, nMinute, nSecond);

	// Now set the text of the pane
	CStatusBar* pStatusBar = GetStatusBar();
	pStatusBar->SetPaneText(pStatusBar->CommandToIndex(ID_INDICATOR_TIME),
							LPCSTR(szTime));
	pCmdUI->Enable();
}

/////////////////////////////////////////////////////////////////////////////
// CWndClientDlg::OnButtonOpen()

void CWndClientDlg::OnButtonOpen()
{
	// allow user to select database to open
	CFileDialog dlg (TRUE, _T(""), NULL, OFN_HIDEREADONLY,
					 _T("All Files (*.*)|*.*||"),
					 this);

	// if user selected a file then open it as a database
	if (IDOK == dlg.DoModal())
	{
		// get full path to database file
		m_strStorageFile = dlg.GetPathName();

		// display the name of the database on the dialog
		UpdateData(FALSE);
	}
}
