// MdlsMain.h : header file

#ifndef __MDLSMAIN_H__
#define __MDLSMAIN_H__

#include "modeless.h"
#include "dlgbars.h"

class CModelessMain : public CModelessDialog
{
	DECLARE_DYNAMIC(CModelessMain)

// Construction
public:
	CModelessMain();
	BOOL Create(LPCSTR lpszTemplateName,
				const UINT FAR* lpaIDStatus, int cIDStatus,
				const UINT FAR* lpaIDToolbar, int cIDToolbar,
				UINT nIDBitmap);
	BOOL Create(UINT nIDTemplate,
				const UINT FAR* lpaIDStatus, int cIDStatus,
				const UINT FAR* lpaIDToolbar, int cIDToolbar,
				UINT nIDBitmap);

// Attributes
public:
	CStatusBar* GetStatusBar() { return &m_statusBar; }
	CToolBar*   GetToolBar()   { return &m_toolBar; }

// Implementation
public:
	virtual ~CModelessMain();

	// Overrides
	virtual BOOL OnInitDialog();

protected:
	HICON           m_hIcon;

	UINT            m_nIDTracking;
	UINT            m_nIDLastMessage;

	const UINT FAR* m_lpaIDStatusBar;
	int             m_cIDStatusBar;
	CDlgStatusBar   m_statusBar;

	const UINT FAR* m_lpaIDToolBar;
	int             m_cIDToolBar;
	UINT            m_nIDBitmap;
	CDlgToolBar     m_toolBar;

	// Generated message map functions
	//{{AFX_MSG(CModelessMain)
	afx_msg void OnClose();
	afx_msg void OnPaint();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnEnterIdle(UINT nWhy, CWnd* pWho);
	afx_msg void OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu);
	afx_msg void OnMenuSelect(UINT nItemID, UINT nFlags, HMENU hSysMenu);
	afx_msg LRESULT OnSetMessageString(WPARAM wParam, LPARAM lParam = 0L);
	afx_msg void OnStatusBarCheck();
	afx_msg void OnToolBarCheck();
	afx_msg void OnUpdateStatusBarMenu(CCmdUI* pCmdUI);
	afx_msg void OnUpdateToolBarMenu(CCmdUI* pCmdUI);
	afx_msg BOOL OnToolTipText(UINT, NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif //__MDLSMAIN_H__
